import type { Match } from 'found';
import type { CacheConfig, Environment, FetchPolicy, GraphQLTaggedNode, Variables } from 'relay-runtime';
import QuerySubscription, { QuerySubscriptionOptions } from './QuerySubscription';
export default class Resolver {
    private lastQuerySubscriptions;
    environment: Environment;
    constructor(environment: Environment);
    protected createQuerySubscription(options: QuerySubscriptionOptions): QuerySubscription;
    resolveElements(match: Match): AsyncGenerator<any[] | undefined, void, unknown>;
    getRouteVariables(match: Match, routeMatches: any[]): any;
    updateQuerySubscriptions(queries: Array<GraphQLTaggedNode | null | undefined>, routeVariables: Array<Variables | null | undefined>, cacheConfigs: Array<CacheConfig | null | undefined>, fetchPolicies: Array<FetchPolicy | null | undefined>): (QuerySubscription | null)[];
    createElements(routeMatches: any[], Components: any[], querySubscriptions: Array<QuerySubscription | null>, fetched: boolean): any[];
}
